/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package form;

import Helpers.FileHelper;
import Helpers.MessageHelper;
import common.constants;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import models.accountObj;
import models.classObj;
import models.enumObj;
import models.pointObj;
import models.timetableObj;

/**
 *
 * @author HoiNT2
 */
public class frmQLPoint extends javax.swing.JFrame {

    private static String filePath = "data/";
    private static String fileClassPath = "data/Class.csv";
    private static String fileCoursePath = "data/";
    ArrayList<classObj> lstClass = new ArrayList<>();
    ArrayList<pointObj> lstPointNew = null;
    accountObj acc = null;

    /**
     * Creates new form frmQLPoint
     */
    public frmQLPoint() {
        initComponents();
        initClass();
        txt_code.hide();

    }

    public frmQLPoint(accountObj acc) {
        this.acc = acc;
        initComponents();
        initClass();
        txt_code.hide();
        review();

    }

    public void review() {
        if (acc != null && acc.getGroupId() == 1) {
            jpanel_header.hide();
            jpanel_statistic.hide();
            if (lstClass != null && lstClass.size() > 0) {
                HashMap<String, ArrayList<pointObj>> mapPoint = new HashMap<String, ArrayList<pointObj>>();
                for (classObj item : lstClass) {
                    try {
                        String fileName = fileCoursePath + "TKB" + item.getName() + ".csv";
                        ArrayList<timetableObj> lsttime = FileHelper.readFileNew(timetableObj.class, fileName, enumObj.timetableObj);
                        if (lsttime != null && lsttime.size() > 0) {
                            try {
                                for (timetableObj itemTime : lsttime) {
                                    String fileNameTime = filePath + item.getName() + "-" + itemTime.getCode() + ".csv";
                                    ArrayList<pointObj> lstPoint = FileHelper.readFileNew(pointObj.class, fileNameTime, enumObj.pointObj);
                                    if (lstPoint != null && lstPoint.size() > 0) {
                                        ArrayList<pointObj> lstNewPoint = new ArrayList<>();
                                        lstPoint.stream().filter((itemPoint) -> (itemPoint.getCode().equals(acc.getCode()))).forEach(lstNewPoint::add);
                                        mapPoint.put(item.getName() + "-" + itemTime.getName(), lstNewPoint);
                                    }
                                }

                            } catch (IOException ex) {
                                ex.printStackTrace();
                            }
                        }
                        //TODO: Table sv
                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }
                }
                if (mapPoint != null && mapPoint.size() > 0) {
                    DefaultTableModel tableModelOld = (DefaultTableModel) table_sv.getModel();
                    tableModelOld.setRowCount(0);

                    table_sv.setModel(new javax.swing.table.DefaultTableModel(
                            new Object[][]{},
                            new String[]{
                                "Mã Lớp", "Tên Môn Học", "MSSV", "Họ tên", "Điểm GK", "Điểm CK", "Điểm Khác", "Tổng"
                            }
                    ));
                    DefaultTableModel tableModel = (DefaultTableModel) table_sv.getModel();
                    mapPoint.entrySet().stream().forEach((Map.Entry<String, ArrayList<pointObj>> m) -> {
                        ArrayList<pointObj> lstvalue = (ArrayList<pointObj>) m.getValue();
                        String[] arr = m.getKey().split("-");
                        lstvalue.stream().forEach(x -> {
                            tableModel.addRow(new Object[]{arr[0], arr[1], x.getCode(), x.getStudentName(), x.getMidtermPoint(), x.getEndPoint(), x.getOtherPoint(), x.getFinalGrade()});

                        });
                    });

                    table_sv.setModel(tableModel);
                }
            }
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jpanel_header = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jcbClass = new javax.swing.JComboBox();
        label1 = new java.awt.Label();
        jcbCourse = new javax.swing.JComboBox();
        jLabel6 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        txtGK = new javax.swing.JTextField();
        txtkhac = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        txt_code = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        txtTong = new javax.swing.JTextField();
        txtCK1 = new javax.swing.JTextField();
        btn_update = new javax.swing.JButton();
        btnImport = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        table_sv = new javax.swing.JTable();
        jpanel_statistic = new javax.swing.JPanel();
        jla_total = new java.awt.Label();
        label2 = new java.awt.Label();
        label3 = new java.awt.Label();
        lable_mon = new java.awt.Label();
        jla_pass = new java.awt.Label();
        jla_fail = new java.awt.Label();
        btnXoaSV = new javax.swing.JButton();
        btnThemSV = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel5.setText("Lớp:");

        jcbClass.setName("cbxLop"); // NOI18N
        jcbClass.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcbClassActionPerformed(evt);
            }
        });

        label1.setFont(new java.awt.Font("Dialog", 1, 18)); // NOI18N
        label1.setText("Điểm Sinh Viên");

        jcbCourse.setName("cbxLop"); // NOI18N
        jcbCourse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jcbCourseActionPerformed(evt);
            }
        });

        jLabel6.setText("Môn Học:");

        jLabel1.setText("Điểm GK");

        jLabel2.setText("Điểm khác");

        jLabel3.setText("Điểm CK");

        jLabel4.setText("Điểm Tổng");

        btn_update.setText("Cập Nhật");
        btn_update.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_updateActionPerformed(evt);
            }
        });

        btnImport.setText("Import");
        btnImport.setMaximumSize(new java.awt.Dimension(77, 23));
        btnImport.setMinimumSize(new java.awt.Dimension(77, 23));
        btnImport.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnImportActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jpanel_headerLayout = new javax.swing.GroupLayout(jpanel_header);
        jpanel_header.setLayout(jpanel_headerLayout);
        jpanel_headerLayout.setHorizontalGroup(
            jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanel_headerLayout.createSequentialGroup()
                .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jpanel_headerLayout.createSequentialGroup()
                        .addGap(42, 42, 42)
                        .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jLabel1)
                                .addComponent(jLabel3))
                            .addComponent(jLabel5))
                        .addGap(18, 18, 18)
                        .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(txtCK1)
                            .addComponent(jcbClass, 0, 194, Short.MAX_VALUE)
                            .addComponent(txtGK))
                        .addGap(56, 56, 56)
                        .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jLabel6)
                                .addComponent(jLabel2))
                            .addComponent(jLabel4)))
                    .addGroup(jpanel_headerLayout.createSequentialGroup()
                        .addGap(285, 285, 285)
                        .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(6, 6, 6)
                .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jcbCourse, 0, 200, Short.MAX_VALUE)
                    .addComponent(txtTong)
                    .addComponent(txtkhac, javax.swing.GroupLayout.Alignment.LEADING))
                .addGap(61, 61, 61)
                .addComponent(txt_code, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(42, 42, 42))
            .addGroup(jpanel_headerLayout.createSequentialGroup()
                .addGap(257, 257, 257)
                .addComponent(btn_update, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(btnImport, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jpanel_headerLayout.setVerticalGroup(
            jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanel_headerLayout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jpanel_headerLayout.createSequentialGroup()
                        .addComponent(label1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(19, 19, 19)
                        .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel5)
                            .addComponent(jcbClass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel6))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(txtGK, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel2)
                                .addComponent(txt_code, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel3)
                                .addComponent(txtCK1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel4)))
                    .addGroup(jpanel_headerLayout.createSequentialGroup()
                        .addComponent(jcbCourse, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtkhac, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(txtTong, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jpanel_headerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_update)
                    .addComponent(btnImport, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(14, Short.MAX_VALUE))
        );

        table_sv.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null},
                {null, null, null, null, null, null, null}
            },
            new String [] {
                "STT", "MSSV", "Họ tên", "Điểm GK", "Điểm CK", "Điểm Khác", "Tổng"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.Object.class, java.lang.Object.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class, java.lang.Float.class
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }
        });
        table_sv.addAncestorListener(new javax.swing.event.AncestorListener() {
            public void ancestorMoved(javax.swing.event.AncestorEvent evt) {
            }
            public void ancestorAdded(javax.swing.event.AncestorEvent evt) {
                table_svAncestorAdded(evt);
            }
            public void ancestorRemoved(javax.swing.event.AncestorEvent evt) {
            }
        });
        table_sv.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                table_svMouseClicked(evt);
            }
        });
        jScrollPane2.setViewportView(table_sv);

        jla_total.setText("0");

        label2.setText("Tỷ lệ rớt(%):");

        label3.setText("Tỷ lệ đậu(%):");

        lable_mon.setText("Tổng số sinh viên:");

        jla_pass.setText("0");

        jla_fail.setText("0");

        btnXoaSV.setText("Xóa sinh viên");
        btnXoaSV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnXoaSVActionPerformed(evt);
            }
        });

        btnThemSV.setText("Thêm sinh viên");
        btnThemSV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnThemSVActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jpanel_statisticLayout = new javax.swing.GroupLayout(jpanel_statistic);
        jpanel_statistic.setLayout(jpanel_statisticLayout);
        jpanel_statisticLayout.setHorizontalGroup(
            jpanel_statisticLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanel_statisticLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lable_mon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jla_total, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(81, 81, 81)
                .addComponent(label3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jla_pass, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(40, 40, 40)
                .addComponent(label2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jla_fail, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(47, 47, 47)
                .addComponent(btnXoaSV)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnThemSV, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jpanel_statisticLayout.setVerticalGroup(
            jpanel_statisticLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jpanel_statisticLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jpanel_statisticLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jpanel_statisticLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btnXoaSV)
                        .addComponent(btnThemSV))
                    .addGroup(jpanel_statisticLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jla_fail, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jla_pass, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(lable_mon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jla_total, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(label2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(label3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(39, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 851, Short.MAX_VALUE)
                            .addComponent(jpanel_statistic, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jpanel_header, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(38, 38, 38))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jpanel_header, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jpanel_statistic, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(23, 23, 23))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jcbClassActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcbClassActionPerformed
        // TODO add your handling code here:
        loadStudents();
        loadCourse();
        resetForm();
    }//GEN-LAST:event_jcbClassActionPerformed

    private void jcbCourseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jcbCourseActionPerformed
        // TODO add your handling code here:
        loadStudents();
    }//GEN-LAST:event_jcbCourseActionPerformed
    private String validatePoint(String masv, String gk, String ck, String other, String finalPoint) {
        return "";
    }
    private void table_svAncestorAdded(javax.swing.event.AncestorEvent evt) {//GEN-FIRST:event_table_svAncestorAdded
        // TODO add your handling code here:

    }//GEN-LAST:event_table_svAncestorAdded
    private void submit() {
        String maSv = txt_code.getText().trim();
        String gk = txtGK.getText().trim();
        String ck = txtCK1.getText().trim();
        String other = txtkhac.getText().trim();
        String finalPoint = txtTong.getText().trim();

        String messgae = validatePoint(maSv, gk, ck, other, finalPoint);
        String nameClass = jcbClass.getSelectedItem().toString();
        String nameCourse = jcbCourse.getSelectedItem().toString();
        if (messgae.isEmpty() && !nameClass.isEmpty() && !nameCourse.isEmpty()) {
            if (lstPointNew != null && lstPointNew.size() > 0) {
                try {
                    for (pointObj o : lstPointNew) {
                        if (maSv.equals(o.getCode())) {
                            o.setMidtermPoint(Float.parseFloat(gk));
                            o.setEndPoint(Float.parseFloat(ck));
                            o.setOtherPoint(Float.parseFloat(other));
                            o.setFinalGrade(Float.parseFloat(finalPoint));
                            break;
                        }
                    }
                    try {
                        String fileName = filePath + nameClass + "-" + nameCourse.split("-")[0] + ".csv";
                        boolean result = FileHelper.writeFile(lstPointNew, fileName, constants.TITLE_POINT);
                        if (result) {
                            setTable(lstPointNew);
                            MessageHelper.Message("Cập nhật điểm thành công của sinh viên: " + maSv);
                        } else {
                            MessageHelper.Message("Lỗi hệ thống.Xin vui lòng thử lại sau");
                        }
                    } catch (IOException ex) {
                        ex.printStackTrace();
                    }
                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this, "Lỗi hệ thống.");
                }

            }
        } else {
            MessageHelper.Message(messgae);
        }
    }
    private void btn_updateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_updateActionPerformed
        // TODO add your handling code here:
        submit();

    }//GEN-LAST:event_btn_updateActionPerformed

    private void table_svMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_table_svMouseClicked
        // TODO add your handling code here:
        int index = table_sv.getSelectedRow();
        if (index > -1) {
            TableModel model = table_sv.getModel();
            String stuentCode = model.getValueAt(index, 1).toString();
            if (!stuentCode.isEmpty() && lstPointNew != null) {
                try {
                    for (pointObj o : lstPointNew) {
                        if (stuentCode.equals(o.getCode())) {
                            txt_code.setText(o.getCode());
                            txtGK.setText(Float.toString(o.getMidtermPoint()));
                            txtCK1.setText(Float.toString(o.getEndPoint()));
                            txtkhac.setText(Float.toString(o.getOtherPoint()));
                            txtTong.setText(Float.toString(o.getFinalGrade()));
                            break;
                        }
                    }

                } catch (Exception ex) {
                    JOptionPane.showMessageDialog(this, "Lỗi hệ thống.");
                }

            }
        }
    }//GEN-LAST:event_table_svMouseClicked
    private int maxSTT() {
        if (lstPointNew == null || lstPointNew.size() == 0) {
            return -1;
        }
        return lstPointNew.stream().max(Comparator.comparing(v -> v.getId())).get().getId();
    }

    public ArrayList<pointObj> findByCodeStudent(String code) {
        ArrayList<pointObj> arr = new ArrayList<>();
        if (lstPointNew == null || lstPointNew.size() == 0) {
            return null;
        }
        lstPointNew.stream().filter((item) -> (item.getCode().equals(code))).forEach((item) -> {
            arr.add(item);
        });
        int size = arr.size();
        if (size > 0) {
            return arr;
        }
        return null;
    }
    private void btnImportActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnImportActionPerformed
        // TODO add your handling code here:
        String textCourse = jcbCourse.getSelectedItem().toString();
        String textClass = jcbClass.getSelectedItem().toString();
        String fileName = "";
        ArrayList<pointObj> lstPointImport = new ArrayList<>();
        if (!textCourse.isEmpty() && !textClass.isEmpty()) {
            String codeCourse = textCourse.split("-")[0];
            try {
                fileName = filePath + textClass + "-" + codeCourse + ".csv";
                lstPointImport = FileHelper.readFileNew(pointObj.class, "", enumObj.pointObj);
                if (lstPointImport == null || lstPointImport.size() == 0) {
                    MessageHelper.Message("File không có dữ liệu");
                    return;
                }
//                int stt = maxSTT();
//                if (stt == -1 || stt > 1) {
//                    stt += 1;
//                }
                
                if (lstPointNew == null) {
                    lstPointNew = new ArrayList<>();
                }

                boolean writeAppend = MessageHelper.showConfirmDialog("Bạn có muốn ghi đè dữ liệu hay không");

                
                if (!lstPointNew.isEmpty()) {
                    lstPointNew = new ArrayList<>();
                }

                int stt = 0;
                // Lấy danh sách điểm điểm hiện tại
                ArrayList<pointObj> lstPointCurrent = FileHelper.readFileNew(pointObj.class, fileName, enumObj.pointObj);

                // Lấy stt tối đa nếu ds đã có
                if (lstPointCurrent != null && !lstPointCurrent.isEmpty()) {
                    stt = lstPointCurrent.get(lstPointCurrent.size() - 1).getId() + 1;
                }

                for (pointObj objPointImport : lstPointImport) {
                    if (lstPointCurrent == null) {
                        lstPointCurrent = new ArrayList<>();
                    }
                    // Nếu điểm import chưa tồn tại trong danh sách điểm đang có thì sẽ add vào, ngược lại sẽ update điểm
                    boolean bExisting = false;
                    for (pointObj objPointCurrent : lstPointCurrent) {
                        if (objPointCurrent.getCode().equals(objPointImport.getCode())) {
                            if (writeAppend) { // cho phép ghi đè điểm
                                objPointCurrent.setMidtermPoint(objPointImport.getMidtermPoint());
                                objPointCurrent.setEndPoint(objPointImport.getEndPoint());
                                objPointCurrent.setOtherPoint(objPointImport.getOtherPoint());
                                objPointCurrent.setFinalGrade(objPointImport.getFinalGrade());
                            }
                            bExisting = true;
                            break;
                        }
                    }
                    // Nếu chưa tồn tại trong danh sách thì thêm vào
                    if (!bExisting) {
                        pointObj stu = new pointObj(stt, objPointImport.getCode(), objPointImport.getStudentName(),
                                objPointImport.getMidtermPoint(), objPointImport.getEndPoint(), objPointImport.getOtherPoint(), objPointImport.getFinalGrade());
                        lstPointCurrent.add(stu);
                        stt += 1;
                    }
                }

                try {
                    boolean result = FileHelper.writeFile(lstPointCurrent, fileName, constants.TITLE_POINT);
                    if (result) {
                        //setTable(lstPointNew);
                        MessageHelper.Message("Import dữ liệu thành công");

                    } else {
                        MessageHelper.Message("Lỗi hệ thống. Xin vui lòng thử lại sau");
                    }
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }

        }
        loadStudents();
    }//GEN-LAST:event_btnImportActionPerformed

    private void btnXoaSVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnXoaSVActionPerformed
        // TODO add your handling code here:
        int rowIndex = table_sv.getSelectedRow();
        if (rowIndex == -1) {
            MessageHelper.Message("Vui lòng chọn sinh viên!", "Thông báo", JOptionPane.ERROR_MESSAGE);
            return;
        }

        boolean resultConfirm = MessageHelper.showConfirmDialog("Bạn có chắc chắn muốn xóa sinh viên không?");
        if (!resultConfirm) {
            return;
            
        }

        String textCourse = jcbCourse.getSelectedItem().toString();
        String textClass = jcbClass.getSelectedItem().toString();
        String mssv = table_sv.getValueAt(rowIndex, 1).toString();
        String codeCourse = textCourse.split("-")[0].trim();
        String fileName = filePath + textClass + "-" + codeCourse + ".csv";
        try {
            ArrayList<pointObj> lstPointCurrent = FileHelper.readFileNew(pointObj.class, fileName, enumObj.pointObj);
            if (lstPointCurrent != null && !lstPointCurrent.isEmpty()) {
                for (pointObj obj : lstPointCurrent) {
                    if (obj.getCode().equals(mssv)) {
                        lstPointCurrent.remove(obj);
                        break;
                    }
                }
                for (int i = 0; i < lstPointCurrent.size(); i++) {
                    lstPointCurrent.get(i).setId(i);
                }

                boolean result = FileHelper.writeFile(lstPointCurrent, fileName, constants.TITLE_POINT);
                if (result) {
                    MessageHelper.Message("Xóa sinh viên thành công!");
                } else {
                    MessageHelper.Message("Xóa sinh viên thất bại. Vui lòng thử lại.");
                }

                loadStudents();
            }

        } catch (Exception e) {

        }

    }//GEN-LAST:event_btnXoaSVActionPerformed

    private void btnThemSVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnThemSVActionPerformed
        // TODO add your handling code here:
        frmThemSinhVienVaoMon frm = new frmThemSinhVienVaoMon(this, true);
        frm.setVisible(true);
    }//GEN-LAST:event_btnThemSVActionPerformed
    public void setTable(ArrayList<pointObj> lst) {
        try {
            if (lst == null) {
                JOptionPane.showMessageDialog(this, "Hệ thống bị lỗi không lấy đươc dữ liêu.");
                return;
            }
            DefaultTableModel tableModel = (DefaultTableModel) table_sv.getModel();
            tableModel.setRowCount(0);
            lst.stream().forEach(x -> {
                tableModel.addRow(new Object[]{x.getId(), x.getCode(), x.getStudentName(), x.getMidtermPoint(), x.getEndPoint(), x.getOtherPoint(), x.getFinalGrade()});
            });
            table_sv.setModel(tableModel);
            int total = lst.size();
            jla_total.setText(Integer.toString(total));
            long totalPass = lst.stream().filter(x -> x.getFinalGrade() >= 5).count();

            
            if (total == 0) {
                jla_pass.setText("0");
                jla_fail.setText("0");
            } else {
                float percentPass = (((float) totalPass / total) * 100);
                jla_pass.setText(Float.toString(percentPass));
                jla_fail.setText(Float.toString(100 - percentPass));
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this, "Hệ thống bị lỗi không lấy đươc dữ liêu.");
        }
    }

    public void loadStudents() {
        if (jcbClass.getSelectedItem() == null || jcbCourse.getSelectedItem() == null) {
            setTable(new ArrayList<>());
            return;
        }
        String textCourse = jcbCourse.getSelectedItem().toString();
        String textClass = jcbClass.getSelectedItem().toString();
        if (!textCourse.isEmpty() && !textClass.isEmpty()) {
            String codeCourse = textCourse.split("-")[0];
            String fileName = filePath + textClass + "-" + codeCourse + ".csv";
            try {
                lstPointNew = FileHelper.readFileNew(pointObj.class, fileName, enumObj.pointObj);
                if (lstPointNew != null && lstPointNew.size() > 0) {
                    setTable(lstPointNew);
                } else {
                    // reset
                    lstPointNew = null;
                    DefaultTableModel tableModel = (DefaultTableModel) table_sv.getModel();
                    tableModel.setRowCount(0);
                    resetForm();
                }
                //TODO: Table sv
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        } else {
            setTable(new ArrayList<>());
        }

    }

    private void resetForm() {
        txt_code.setText("");
        txtGK.setText("");
        txtCK1.setText("");
        txtkhac.setText("");
        txtTong.setText("");
        if (lstPointNew == null) {
            jla_pass.setText("0");
            jla_total.setText("0");
            jla_fail.setText("0");
        }
    }

    private void loadCourse() {
        String text = jcbClass.getSelectedItem().toString();
        jcbCourse.setModel(new DefaultComboBoxModel());
        resetForm();
        if (!text.isEmpty()) {
            try {
                String fileName = fileCoursePath + "TKB" + text + ".csv";
                ArrayList<timetableObj> lsttime = FileHelper.readFileNew(timetableObj.class, fileName, enumObj.timetableObj
                );
                if (lsttime != null && lsttime.size() > 0) {
                    lsttime.stream().forEach((itemGroup) -> {
                        jcbCourse.addItem(itemGroup.getCode() + "-" + itemGroup.getName());
                    });
                    loadStudents();
                }
                //TODO: Table sv
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }

    private void initClass() {
        try {
            lstClass = FileHelper.readFileNew(classObj.class, fileClassPath, enumObj.classObj);
            if (lstClass != null && lstClass.size() > 0) {
                lstClass.stream().forEach((itemGroup) -> {
                    jcbClass.addItem(itemGroup);
                });
            }
            //TODO: Table sv
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(frmQLPoint.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(frmQLPoint.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(frmQLPoint.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(frmQLPoint.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new frmQLPoint().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnImport;
    private javax.swing.JButton btnThemSV;
    private javax.swing.JButton btnXoaSV;
    private javax.swing.JButton btn_update;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JComboBox jcbClass;
    private javax.swing.JComboBox jcbCourse;
    private java.awt.Label jla_fail;
    private java.awt.Label jla_pass;
    private java.awt.Label jla_total;
    private javax.swing.JPanel jpanel_header;
    private javax.swing.JPanel jpanel_statistic;
    private java.awt.Label label1;
    private java.awt.Label label2;
    private java.awt.Label label3;
    private java.awt.Label lable_mon;
    private javax.swing.JTable table_sv;
    private javax.swing.JTextField txtCK1;
    private javax.swing.JTextField txtGK;
    private javax.swing.JTextField txtTong;
    private javax.swing.JTextField txt_code;
    private javax.swing.JTextField txtkhac;
    // End of variables declaration//GEN-END:variables
}
